﻿UsePNGImageDecoder()
InitSprite()
InitKeyboard()

Structure TMX_Image
  source.s
  trans.s
  width.i
  height.i
EndStructure

Structure TMX_Data
  encoding.s
  bdata.s
EndStructure

Structure TMX_Tile
  id.i
  sprite.i
  flipHorizontal.i
  flipVertical.i
  flipDiagonal.i
EndStructure

Structure TMX_Tileset
  firstGID.i
  lastGID.i
  name.s
  tileWidth.i
  tileHeight.i
  tileCount.i
  columns.i
  spacing.i
  margin.i
  image.TMX_Image
  offsetX.i
  offsetY.i
EndStructure

Structure TMX_Layer
  name.s
  width.i
  height.i
  opacity.f
  isVisible.i
  offsetX.i
  offsetY.i
  tdata.TMX_Data
EndStructure

Structure TMX_Map
  orientation.s
  renderorder.s
  width.i
  height.i
  tileWidth.i
  tileHeight.i
  pixelWidth.i
  pixelHeight.i
  infinite.i
  nextobjectid.i
  bgColor.s
  x.i
  y.i
EndStructure

Global tmap.TMX_Map
Global Dim tlayer.TMX_Layer(100)
Global Dim tileset.TMX_Tileset(100)
Global Dim tile.TMX_Tile(10000)

Global i=0, j=0, k=0, m=0, n=0

Global xpos=0, ypos=0

Procedure.s DecodeMap(encoding.s, bdata.s)
  Protected *bmap, pstring.s
  If encoding = "base64"
    *bmap = AllocateMemory(@bdata)
    Debug bdata
    Base64Decoder(bdata, *bmap, MemorySize(*bmap))
    pstring.s = ""
    For j = 0 To (tmap\width * tmap\height)-1
      pstring = pstring + Str(PeekU(*bmap)) + ","
      *bmap + 4
    Next j
    ProcedureReturn pstring
  EndIf
EndProcedure

Procedure ParseTMXFile(*CurrentNode, CurrentSublevel)
  If XMLNodeType(*CurrentNode) = #PB_XML_Normal
    If GetXMLNodeName(*CurrentNode) = "map"
      If ExamineXMLAttributes(*CurrentNode)
        While NextXMLAttribute(*CurrentNode)
          Select XMLAttributeName(*CurrentNode)
            Case "orientation"
              tmap\orientation = XMLAttributeValue(*CurrentNode)
              Debug tmap\orientation
            Case "renderorder"
              tmap\renderorder = XMLAttributeValue(*CurrentNode)
              Debug tmap\renderorder
            Case "width"
              tmap\width = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\width
            Case "height"
              tmap\height = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\height
            Case "tilewidth"
              tmap\tileWidth = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\tileWidth
            Case "tileheight"
              tmap\tileHeight = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\tileHeight
            Case "pixelwidth"
              tmap\pixelWidth = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\pixelWidth
            Case "pixelheight"
              tmap\pixelHeight = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\pixelHeight
            Case "infinite"
              tmap\infinite = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\infinite
            Case "nextobjectid"
              tmap\nextobjectid = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\nextobjectid
            Case "bgcolor"
              tmap\bgColor = XMLAttributeValue(*CurrentNode)
              Debug tmap\bgColor
            Case "x"
              tmap\x = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\x
            Case "y"
              tmap\y = Val(XMLAttributeValue(*CurrentNode))
              Debug tmap\y
          EndSelect
        Wend
      EndIf
    ElseIf GetXMLNodeName(*CurrentNode) = "tileset"
      If ExamineXMLAttributes(*CurrentNode)
        While NextXMLAttribute(*CurrentNode)
          Select XMLAttributeName(*CurrentNode)
            Case "firstgid"
              tileset(i)\firstGID = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\firstGID
            Case "lastgid"
              tileset(i)\lastGID = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\lastGID
            Case "name"
              tileset(i)\name = XMLAttributeValue(*CurrentNode)
              Debug tileset(i)\name
            Case "tilewidth"
              tileset(i)\tileWidth = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\tileWidth
            Case "tileheight"
              tileset(i)\tileHeight = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\tileHeight
            Case "tilecount"
              tileset(i)\tileCount = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\tileCount
            Case "columns"
              tileset(i)\columns = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\columns
            Case "spacing"
              tileset(i)\spacing = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\spacing
            Case "margin"
              tileset(i)\margin = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\margin
            Case "offsetx"
              tileset(i)\offsetX = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\offsetX
            Case "offsety"
              tileset(i)\offsetY = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(i)\offsetY
          EndSelect
        Wend
      EndIf
      i + 1
    ElseIf GetXMLNodeName(*CurrentNode) = "image"
      If ExamineXMLAttributes(*CurrentNode)
        While NextXMLAttribute(*CurrentNode)
          Select XMLAttributeName(*CurrentNode)
            Case "source"
              tileset(j)\image\source = XMLAttributeValue(*CurrentNode)
              Debug tileset(j)\image\source
            Case "trans"
              tileset(j)\image\trans = XMLAttributeValue(*CurrentNode)
              Debug tileset(j)\image\source
            Case "width"
              tileset(j)\image\width = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(j)\image\width
            Case "height"
              tileset(j)\image\height = Val(XMLAttributeValue(*CurrentNode))
              Debug tileset(j)\image\height
          EndSelect
        Wend
      EndIf
      j + 1
    ElseIf GetXMLNodeName(*CurrentNode) = "tile"
      If ExamineXMLAttributes(*CurrentNode)
        While NextXMLAttribute(*CurrentNode)
          Select XMLAttributeName(*CurrentNode)
            Case "id"
              tile(k)\id = Val(XMLAttributeValue(*CurrentNode))
              Debug tile(k)\id
          EndSelect
        Wend
      EndIf
      k + 1
    ElseIf GetXMLNodeName(*CurrentNode) = "layer"
      If ExamineXMLAttributes(*CurrentNode)
        While NextXMLAttribute(*CurrentNode)
          Select XMLAttributeName(*CurrentNode)
            Case "name"
              tlayer(m)\name = XMLAttributeValue(*CurrentNode)
              Debug tlayer(m)\name
            Case "width"
              tlayer(m)\width = Val(XMLAttributeValue(*CurrentNode))
              Debug tlayer(m)\width
            Case "height"
              tlayer(m)\height = Val(XMLAttributeValue(*CurrentNode))
              Debug tlayer(m)\height
            Case "opacity"
              tlayer(m)\opacity = ValF(XMLAttributeValue(*CurrentNode))
              Debug tlayer(m)\opacity
            Case "visible"
              tlayer(m)\isVisible = Val(XMLAttributeValue(*CurrentNode))
              Debug tlayer(m)\isVisible
            Case "offsetx"
              tlayer(m)\offsetX = Val(XMLAttributeValue(*CurrentNode))
              Debug tlayer(m)\offsetX
            Case "offsety"
              tlayer(m)\offsetY = Val(XMLAttributeValue(*CurrentNode))
              Debug tlayer(m)\offsetY
          EndSelect
        Wend
      EndIf
      m + 1
    ElseIf GetXMLNodeName(*CurrentNode) = "data"
      If ExamineXMLAttributes(*CurrentNode)
        While NextXMLAttribute(*CurrentNode)
          Select XMLAttributeName(*CurrentNode)
            Case "encoding"
              tlayer(n)\tdata\encoding = XMLAttributeValue(*CurrentNode)
              Debug tlayer(n)\tdata\encoding
              tlayer(n)\tdata\bdata = RTrim(Trim(Trim(Trim(GetXMLNodeText(*CurrentNode),Chr(13)),Chr(10)),Chr(32)),Chr(61))
              Debug tlayer(n)\tdata\bdata
          EndSelect
        Wend
      EndIf
      n + 1
    EndIf
    *ChildNode = ChildXMLNode(*CurrentNode)
    While *ChildNode <> 0
      ParseTMXFile(*ChildNode, CurrentSublevel + 1)      
      *ChildNode = NextXMLNode(*ChildNode)
    Wend        
  EndIf
EndProcedure

Procedure LoadTileset(*tset.TMX_Tileset)
  Debug *tset\image\source
  If LoadSprite(0, *tset\image\source)
    Global sw = SpriteWidth(0)
    Global sh = SpriteHeight(0)
  Else
    End
  EndIf
EndProcedure

Procedure DisplayTile(tid, x, y)
  If tid > 0
    If tid <= (sw / tileset(0)\tileWidth)
      calcX = (tid * tileset(0)\tileWidth)-tileset(0)\tileWidth
      ClipSprite(0, calcX, 0, tileset(0)\tileWidth, tileset(0)\tileHeight)
    EndIf
    For q = 2 To (sh / tileset(0)\tileHeight)-1
      If tid > (sw / tileset(0)\tileWidth) And tid <= (sw / tileset(0)\tileWidth)*q
        tcalc = (sw / tileset(0)\tileWidth) * (q-1)
        calcX = ((tid - tcalc) * tileset(0)\tileWidth)-tileset(0)\tileWidth
        calcY = tileset(0)\tileHeight * (q-1)
        ClipSprite(0, calcX, calcY, tileset(0)\tileWidth, tileset(0)\tileHeight)
        Break
      EndIf
    Next q
    DisplayTransparentSprite(0, x, y)
  EndIf
EndProcedure

Procedure DrawIsoMap(level.s, x_start, y_start)
  xpos = x_start : ypos = y_start : t = 32
  x_count = x_start : y_count = y_start

  For v = 1 To 32
    For h = 1 To 32
      If Val(StringField(level, t, ",")) <> 0
        DisplayTile(Val(StringField(level, t, ",")), xpos, ypos)
      EndIf
      xpos-32
      ypos-16
      t - 1
    Next h
    t + 64
    x_count - 32
    y_count + 16
    xpos = x_count
    ypos = y_count
  Next v
EndProcedure

FileName$ = OpenFileRequester("Wähle eine TMX-Datei.", "", "tmx files (*.tmx)|*.tmx", 0)
If FileName$ <> ""
  If LoadXML(0, FileName$)
    *MainNode = MainXMLNode(0)      
    If *MainNode
      ParseTMXFile(*MainNode, 0)
    EndIf
  EndIf
EndIf

If OpenWindow(0, 0, 0, (tmap\width * tmap\tileWidth), (tmap\height * tmap\tileHeight), "Tilemap-Test", #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_ScreenCentered)
  SetWindowColor(0,RGB(0,0,0))
  If OpenWindowedScreen(WindowID(0), 0, 0, (tmap\width * tmap\tileWidth), (tmap\height * tmap\tileHeight))
    SetFrameRate(60)
    LoadTileset(@tileset(0))
    Global cx = ScreenWidth()-32
    Global cy = (ScreenHeight()/2)+16
    Global xmap1.s = DecodeMap(tlayer(0)\tdata\encoding, tlayer(0)\tdata\bdata)
    Global xmap2.s = DecodeMap(tlayer(1)\tdata\encoding, tlayer(1)\tdata\bdata)
    Global xmap3.s = DecodeMap(tlayer(2)\tdata\encoding, tlayer(2)\tdata\bdata)
    Repeat
   
      Event = WindowEvent()
      
      Select Event
        Case #PB_Event_CloseWindow
          quit = #True
          
        Case #PB_Event_Gadget
          
      EndSelect
      
      ClearScreen(0)
      
      DrawIsoMap(xmap1, cx, cy)
      DrawIsoMap(xmap2, cx, cy)
      DrawIsoMap(xmap3, cx, cy)
      
      ExamineKeyboard()
      
      If KeyboardPushed(#PB_Key_Left)
        cx + 32
      ElseIf KeyboardPushed(#PB_Key_Right)
        cx - 32
      ElseIf KeyboardPushed(#PB_Key_Up)
        cy + 32
      ElseIf KeyboardPushed(#PB_Key_Down)
        cy - 32
      EndIf
    
    FlipBuffers()
    Delay(20)
    Until quit
  EndIf
EndIf
; IDE Options = PureBasic 5.70 LTS beta 2 (Windows - x64)
; CursorPosition = 352
; FirstLine = 320
; Folding = -
; EnableThread
; EnableXP
; CompileSourceDirectory